import es, playerlib, popuplib

admins = ['STEAM_0:0:xxxxxxxxx']		##  SteamID of admins

def load():
	es.set('bot_auto_balance', '0', 'One bot will automatically join/be kicked if teams are not equal')
	es.set('bot_auto_kill', '0', 'Automatic bots kill if no human player is alive')
	es.regclientcmd('admin_botmenu', 'botplugin/check_admin')

def unload():
	es.unregclientcmd('admin_botmenu')

def check_admin():
	userid = es.getcmduserid()
	if es.getplayersteamid(userid) not in admins:
		es.tell(userid, '#multi', '#defaultYou are not #lightgreenAdmin#default. You cannot use this command')
		return
	botmain(userid)

def botmain(userid):
	if not popuplib.exists('botmain'):
		botmain = popuplib.create('botmain')
		botmain.addline('Bot Main Menu')
		botmain.addline('-------------------------')
		botmain.addline('->1. Add one bot')
		botmain.addline('->2. Remove one bot')
		botmain.addline('->3. Kill all bots')
		botmain.addline('->4. Remove all bots')
		botmain.addline(' ')
		botmain.addline('->7. Common settings')
		botmain.addline('->8. Advanced settings')
		botmain.addline('->9. Weapon settings')
		botmain.addline('0. Cancel')
		botmain.timeoutview = 15
		botmain.menuselect = botmain_menu
	if popuplib.isqueued('botmain', userid): popuplib.close('botmain', userid)
	popuplib.send('botmain', userid)

def botset(userid):
	if es.server_var['bot_auto_balance'] == 1:
		autobalance = 'yes'
	else: autobalance = 'no'
	if int(es.server_var['bot_auto_kill']) == 1:
		autokill = 'yes'
	else: autokill = 'no'
	if es.server_var['bot_defer_to_human'] == 1:
		botdefer = 'yes'
	else: botdefer = 'no'
	if es.server_var['bot_difficulty'] == 1:
		botdif = 'normal'
	elif es.server_var['bot_difficulty'] == 2:
		botdif = 'hard'
	elif es.server_var['bot_difficulty'] == 3:
		botdif = 'expert'
	else: botdif = 'easy'
	if int(es.server_var['bot_stop']) == 1:
		botfreeze = 'on'
	else: botfreeze = 'off'
	botset = popuplib.create('botset')
	botset.addline('Bot Settings Menu')
	botset.addline('-------------------------')
	botset.addline('->1. Bots auto balance: ' + autobalance)
	botset.addline('->2. Bots auto kill: ' + autokill)
	botset.addline('->3. Bots chatter: ' + es.server_var['bot_chatter'])
	botset.addline('->4. Bots defer to human: ' + botdefer)
	botset.addline('->5. Bots difficulty: ' + botdif)
	botset.addline('->6. Bots freeze: ' + botfreeze)
	botset.addline('->7. Bots join team: ' + es.server_var['bot_join_team'])
	botset.addline(' ')
	botset.addline('->9. Back to main menu')
	botset.addline('0. Cancel')
	botset.timeoutview = 15
	botset.menuselect = botset_menu
	popuplib.send('botset', userid)

def botadv(userid):
	if es.server_var['bot_allow_rogues'] == 1:
		botrogue = 'yes'
	else: botrogue = 'no'
	if es.server_var['bot_auto_follow'] == 1:
		botfollow = 'yes'
	else: botfollow = 'no'
	if es.server_var['bot_auto_vacate'] == 1:
		botvacate = 'yes'
	else: botvacate = 'no'
	if es.server_var['bot_join_after_player'] == 1:
		botjoin = 'yes'
	else: botjoin = 'no'
	if es.server_var['bot_prefix'] == '<difficulty>':
		botprefix = 'difficulty'
	elif es.server_var['bot_prefix'] == '<weaponclass>':
		botprefix = 'weapon class'
	elif es.server_var['bot_prefix'] == '<skill>':
		botprefix = 'skill'
	else: botprefix = 'none'
	if es.server_var['bot_walk'] == 1:
		botwalk = 'yes'
	else: botwalk = 'no'
	botadv = popuplib.create('botadv')
	botadv.addline('Advanced Settings')
	botadv.addline('-------------------------')
	botadv.addline('->1. Bots allow rogues: ' + botrogue)
	botadv.addline('->2. Bots auto follow: ' + botfollow)
	botadv.addline('->3. Bots auto vacate: ' + botvacate)
	botadv.addline('->4. Bots join after player: ' + botjoin)
	botadv.addline('->5. Bots prefix: ' + botprefix)
	botadv.addline('->6. Bots quota mode: ' + es.server_var['bot_quota_mode'])
	botadv.addline('->7. Bots walk only: ' + botwalk)
	botadv.addline(' ')
	botadv.addline('->9. Back to main menu')
	botadv.addline('0. Cancel')
	botadv.timeoutview = 15
	botadv.menuselect = botadv_menu
	popuplib.send('botadv', userid)

def botwep(userid):
	if es.server_var['bot_allow_pistols'] == 1:
		pistols = 'yes'
	else: pistols = 'no'
	if es.server_var['bot_allow_sub_machine_guns'] == 1:
		submachines = 'yes'
	else: submachines = 'no'
	if es.server_var['bot_allow_shotguns'] == 1:
		shotguns = 'yes'
	else: shotguns = 'no'
	if es.server_var['bot_allow_machine_guns'] == 1:
		machines = 'yes'
	else: machines = 'no'
	if es.server_var['bot_allow_rifles'] == 1:
		rifles = 'yes'
	else: rifles = 'no'
	if es.server_var['bot_allow_snipers'] == 1:
		snipers = 'yes'
	else: snipers = 'no'
	if es.server_var['bot_allow_grenades'] == 1:
		grenades = 'yes'
	else: grenades = 'no'
	botwep = popuplib.create('botwep')
	botwep.addline('Weapon Settings')
	botwep.addline('-------------------------')
	botwep.addline('->1. Allow Pistols: ' + pistols)
	botwep.addline('->2. Allow Sub Machines: ' + submachines)
	botwep.addline('->3. Allow Shotguns: ' + shotguns)
	botwep.addline('->4. Allow Machine Guns: ' + machines)
	botwep.addline('->5. Allow Rifles: ' + rifles)
	botwep.addline('->6. Allow Snipers: ' + snipers)
	botwep.addline('->7. Allow Grenades: ' + grenades)
	botwep.addline(' ')
	botwep.addline('->9. Back to main menu')
	botwep.addline('0. Cancel')
	botwep.timeoutview = 15
	botwep.menuselect = botwep_menu
	popuplib.send('botwep', userid)

def botmain_menu(userid, choice, popupid):
	if choice == 1:
		if es.server_var['bot_quota'] >= 13:
			es.server_var['bot_quota'] = 13
			es.tell(userid, '#multi', '#defaultMaximum player count reached. You cannot add bots')
		else:
			es.server_var['bot_quota'] = es.server_var['bot_quota'] + 1
			es.tell(userid, '#multi', '#defaultThere are #lightgreen%i#default bots on server now' % es.server_var['bot_quota'])
		botmain(userid)
	elif choice == 2:
		if es.server_var['bot_quota'] <= 0:
			es.server_var['bot_quota'] = 0
			es.tell(userid, '#multi', '#defaultThere are no bots on server. You cannot remove bots')
		else:
			es.server_var['bot_quota'] = es.server_var['bot_quota'] - 1
			es.tell(userid, '#multi', '#defaultThere are #lightgreen%i#default bots on server now' % es.server_var['bot_quota'])
		botmain(userid)
	elif choice == 3:
		if es.server_var['bot_quota'] == 0:
			es.tell(userid, '#multi', '#defaultThere are no bots on server. You cannot kill bots')
		else:
			es.server.cmd('bot_kill')
			es.tell(userid, '#multi', '#defaultYou have #lightgreenslayed#default all the bots')
		botmain(userid)
	elif choice == 4:
		if es.server_var['bot_quota'] == 0:
			es.tell(userid, '#multi', '#defaultThere are no bots on server. You cannot kick bots')
		else:
			es.server.cmd('bot_kick')
			es.tell(userid, '#multi', '#defaultYou have #lightgreenkicked#default all the bots')
		botmain(userid)
	elif choice == 7:
		popuplib.delete('botmain')
		botset(userid)
	elif choice == 8:
		popuplib.delete('botmain')
		botadv(userid)
	elif choice == 9:
		popuplib.delete('botmain')
		botwep(userid)
	else: popuplib.delete('botmain')

def botset_menu(userid, choice, popupid):
	if choice == 1:
		if es.server_var['bot_auto_balance'] == 0:
			es.server_var['bot_auto_balance'] = 1
		else:
			es.server_var['bot_auto_balance'] = 0
		botset(userid)
	elif choice == 2:
		if int(es.server_var['bot_auto_kill']) == 0:
			es.server_var['bot_auto_kill'] = 1
		else:
			es.server_var['bot_auto_kill'] = 0
		botset(userid)
	elif choice == 3:
		if es.server_var['bot_chatter'] == 'normal':
			es.server_var['bot_chatter'] = 'radio'
		elif es.server_var['bot_chatter'] == 'radio':
			es.server_var['bot_chatter'] = 'minimal'
		elif es.server_var['bot_chatter'] == 'minimal':
			es.server_var['bot_chatter'] = 'off'
		else:
			es.server_var['bot_chatter'] = 'normal'
		botset(userid)
	elif choice == 4:
		if es.server_var['bot_defer_to_human'] == 0:
			es.server_var['bot_defer_to_human'] = 1
		else:
			es.server_var['bot_defer_to_human'] = 0
		botset(userid)
	elif choice == 5:
		if es.server_var['bot_difficulty'] < 3:
			es.server_var['bot_difficulty'] = es.server_var['bot_difficulty'] + 1
		else:
			es.server_var['bot_difficulty'] = 0
		botset(userid)
	elif choice == 6:
		if es.server_var['bot_stop'] == 0:
			es.server_var['bot_stop'] = 1
		else:
			es.server_var['bot_stop'] = 0
		botset(userid)
	elif choice == 7:
		if es.server_var['bot_join_team'] == 'any':
			es.server_var['bot_join_team'] = 't'
		elif es.server_var['bot_join_team'] == 't':
			es.server_var['bot_join_team'] = 'ct'
		else:
			es.server_var['bot_join_team'] = 'any'
		botset(userid)
	elif choice == 9:
		popuplib.delete('botset')
		botmain(userid)
	else: popuplib.delete('botset')

def botadv_menu(userid, choice, popupid):
	if choice == 1:
		if es.server_var['bot_allow_rogues'] == 0:
			es.server_var['bot_allow_rogues'] = 1
		else:
			es.server_var['bot_allow_rogues'] = 0
		botadv(userid)
	elif choice == 2:
		if es.server_var['bot_auto_follow'] == 0:
			es.server_var['bot_auto_follow'] = 1
		else:
			es.server_var['bot_auto_follow'] = 0
		botadv(userid)
	elif choice == 3:
		if es.server_var['bot_auto_vacate'] == 0:
			es.server_var['bot_auto_vacate'] = 1
		else:
			es.server_var['bot_auto_vacate'] = 0
		botadv(userid)
	elif choice == 4:
		if es.server_var['bot_join_after_player'] == 0:
			es.server_var['bot_join_after_player'] = 1
		else:
			es.server_var['bot_join_after_player'] = 0
		botadv(userid)
	elif choice == 5:
		if es.server_var['bot_prefix'] == '':
			es.server_var['bot_prefix'] = '<difficulty>'
		elif es.server_var['bot_prefix'] == '<difficulty>':
			es.server_var['bot_prefix'] = '<weaponclass>'
		elif es.server_var['bot_prefix'] == '<weaponclass>':
			es.server_var['bot_prefix'] = '<skill>'
		else:
			es.server_var['bot_prefix'] = ''
		botadv(userid)
	elif choice == 6:
		if es.server_var['bot_quota_mode'] == 'normal':
			es.server_var['bot_quota_mode'] = 'fill'
		elif es.server_var['bot_quota_mode'] == 'fill':
			es.server_var['bot_quota_mode'] = 'match'
		else:
			es.server_var['bot_quota_mode'] = 'normal'
	elif choice == 7:
		if es.server_var['bot_walk'] == 0:
			es.server_var['bot_walk'] = 1
		else:
			es.server_var['bot_walk'] = 0
		botadv(userid)
	elif choice == 9:
		popuplib.delete('botadv')
		botmain(userid)
	else: popuplib.delete('botadv')

def botwep_menu(userid, choice, popupid):
	if choice == 1:
		if es.server_var['bot_allow_pistols'] == 0:
			es.server_var['bot_allow_pistols'] = 1
		else:
			es.server_var['bot_allow_pistols'] = 0
		botwep(userid)
	elif choice == 2:
		if es.server_var['bot_allow_sub_machine_guns'] == 0:
			es.server_var['bot_allow_sub_machine_guns'] = 1
		else:
			es.server_var['bot_allow_sub_machine_guns'] = 0
		botwep(userid)
	elif choice == 3:
		if es.server_var['bot_allow_shotguns'] == 0:
			es.server_var['bot_allow_shotguns'] = 1
		else:
			es.server_var['bot_allow_shotguns'] = 0
		botwep(userid)
	elif choice == 4:
		if es.server_var['bot_allow_machine_guns'] == 0:
			es.server_var['bot_allow_machine_guns'] = 1
		else:
			es.server_var['bot_allow_machine_guns'] = 0
		botwep(userid)
	elif choice == 5:
		if es.server_var['bot_allow_rifles'] == 0:
			es.server_var['bot_allow_rifles'] = 1
		else:
			es.server_var['bot_allow_rifles'] = 0
		botwep(userid)
	elif choice == 6:
		if es.server_var['bot_allow_snipers'] == 0:
			es.server_var['bot_allow_snipers'] = 1
		else:
			es.server_var['bot_allow_snipers'] = 0
		botwep(userid)
	elif choice == 7:
		if es.server_var['bot_allow_grenades'] == 0:
			es.server_var['bot_allow_grenades'] = 1
		else:
			es.server_var['bot_allow_grenades'] = 0
		botwep(userid)
	elif choice == 9:
		popuplib.delete('botwep')
		botmain(userid)
	else: popuplib.delete('botwep')

def player_death(ev):
	teambalance()
	if len(playerlib.getPlayerList('#human, #alive')): return
	if es.server_var['bot_auto_kill'] == 1: es.server.cmd('bot_kill')

def player_disconnect(ev):
	teambalance()
	if len(playerlib.getPlayerList('#human, #alive')): return
	if es.server_var['bot_auto_kill'] == 1: es.server.cmd('bot_kill')

def round_start(ev):
	teambalance()

def round_end(ev):
	teambalance()

def teambalance():
	if es.getplayercount(3) == es.getplayercount(2): return
	if es.server_var['bot_auto_balance'] == 0: return
	if len(playerlib.getPlayerList('#bot')) > len(playerlib.getPlayerList('#human')):
		es.server_var['bot_quota'] = es.server_var['bot_quota'] - 1
	else: es.server_var['bot_quota'] = es.server_var['bot_quota'] + 1